<!DOCTYPE html>
<html>

<head>
  <title> Task 25.60 ... Danh sách đơn hàng </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="col-12 text-center">
      <h2 style="color:gray">Danh sách đơn hàng</h2>
      <table id="table-order-list" class="table table-hover table-striped">
        <thead class="text-align center" style="text-align: center; vertical-align: middle">
          <tr >
            <th>Code order</th>
            <th>Kích cỡ combo</th>
            <th>Loại pizza</th>
            <th>Nước uống</th>
            <th>Thành tiền</th>
            <th>Họ và tên</th>
            <th>Số điện thoại</th>
            <th>Trạng thái</th>
            <th>Chi tiết</th>
          </tr>
        </thead>

        <tbody></tbody>
      
      </table>
            
    </div> 
  </div>
  
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gREQUEST_STATUS_OK = 200;
  const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
  const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
  const gBASE_URL_DRINK = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
  const gEND_ROW_TABLE = -1;
  const gCOLUMN_CODE_ORDER = 0;
  const gCOLUMN_COMBO_SIZE = 1;
  const gCOLUMN_PIZZA = 2;
  const gCOLUMN_DRINK = 3;
  const gCOLUMN_AMOUNT = 4;
  const gCOLUMN_FULL_NAME = 5;
  const gCOLUMN_PHONE = 6;
  const gCOLUMN_STATUS = 7;
  const gCOLUMN_DETAIL = 8;

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
 
  function onPageLoading() {
    
    //create order object
    var vOrderObject = {
        id: "",
        orderCode: "",
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "0",
        thanhTien: "",
        giamGia: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "không có",
        trangThai: "",
        ngayTao: "",
        ngayCapNhat: "",
    }   
    
    //call API to get all order from the erver
    var vXmlHttp = new XMLHttpRequest();
    callApiOrder(vXmlHttp);
        vXmlHttp.onreadystatechange = function(){
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
            //console.log("%cRESPONSE-TEXT: ","color:orange",this.responseText);
            showOnTable(this.responseText);
          }
        }
  }

//call API to get all orders from the server
function callApiOrder(paramXmlHttp){
    paramXmlHttp.open("GET", gBASE_URL, true);
    paramXmlHttp.send();
  }

//display to the web form
function showOnTable(paramOrder){

  //parsing the json response from the server
  var vOrderParsing = JSON.parse(paramOrder);
  console.log("%cRESPONSE-PARSED: ","color:orange",vOrderParsing);

  //call element of the table
  var vTableElement = document.getElementById("table-order-list");
  var vTableBody = vTableElement.getElementsByTagName("tbody")[0];

  for (var i=0; i<vOrderParsing.length; i++){
      //create a new row in the table
      var vNewRow = vTableBody.insertRow(gEND_ROW_TABLE);
      //creat new cells in the row
      var vCodeOrderCell = vNewRow.insertCell(gCOLUMN_CODE_ORDER);
      var vComboCell = vNewRow.insertCell(gCOLUMN_COMBO_SIZE);
      var vPizzaCell = vNewRow.insertCell(gCOLUMN_PIZZA);
      var vDrinkCell = vNewRow.insertCell(gCOLUMN_DRINK);
      var vAmountCell = vNewRow.insertCell(gCOLUMN_AMOUNT);
      var vFullNameCell = vNewRow.insertCell(gCOLUMN_FULL_NAME);
      var vPhoneCell = vNewRow.insertCell(gCOLUMN_PHONE);
      var vStatusCell = vNewRow.insertCell(gCOLUMN_STATUS);
      var vDetailCell = vNewRow.insertCell(gCOLUMN_DETAIL);

      var vCellIndex = vOrderParsing[i];
      //load data to the cells
      vCodeOrderCell.innerHTML = vCellIndex.orderCode;
      vComboCell.innerHTML = vCellIndex.kichCo;
      vPizzaCell.innerHTML = vCellIndex.loaiPizza;
      vDrinkCell.innerHTML = vCellIndex.idLoaiNuocUong;
      vAmountCell.innerHTML = vCellIndex.thanhTien;
      vFullNameCell.innerHTML = vCellIndex.hoTen;
      vPhoneCell.innerHTML = vCellIndex.soDienThoai;
      vStatusCell.innerHTML = vCellIndex.trangThai;
      
      //create the detail button
      var vDetailButton = document.createElement("button");
      //append the button to the cell
      vDetailCell.appendChild(vDetailButton);
      vDetailButton.innerHTML = "Chi tiết";
      vDetailButton.className = "btn btn-primary"
      //add event click to the button
      vDetailButton.addEventListener("click", function(){
        onDetailButtonClick(this)})
      //add value dataset for the button
      vDetailButton.setAttribute("data-codeorder", vCellIndex.orderCode);
      vDetailButton.setAttribute("data-combo", vCellIndex.kichCo);
      vDetailButton.setAttribute("data-pizza", vCellIndex.loaiPizza);
      vDetailButton.setAttribute("data-drink", vCellIndex.idLoaiNuocUong);
      vDetailButton.setAttribute("data-amount", vCellIndex.thanhTien);
      vDetailButton.setAttribute("data-full-name", vCellIndex.hoTen);
      vDetailButton.setAttribute("data-phone", vCellIndex.soDienThoai);
      vDetailButton.setAttribute("data-status", vCellIndex.trangThai);
  }
}    

//add function to the detail button
function onDetailButtonClick(paramOrder){

  //get value of the dataset
  var vOrderCode = paramOrder.dataset.codeorder;
  var vCombo = paramOrder.dataset.combo;
  var vPizza = paramOrder.dataset.pizza;
  var vDrink = paramOrder.dataset.drink;
      //console.log("%cNamde of the drink: ", "color:red", vDrink);
  var vAmount = paramOrder.dataset.amount;
  var vFullName = paramOrder.dataset.fullName;
  var vPhone = paramOrder.dataset.phone;
  var vStatus = paramOrder.dataset.status;

  //get data of the drink's list
  var vDrinkApi = callApiDrinkList();
  var vDrinkParsed = JSON.parse(vDrinkApi);
      //console.log("%cNamde of the drink: ", "color:orange", vDrinkParsed[0].tenNuocUong);
      //console.log("%cCode of the drink: ", "color:orange", vDrinkParsed[0].maNuocUong);
  for (var index=0; index < vDrinkParsed.length; index++){
    if (vDrinkParsed[index].maNuocUong === vDrink){
      var vDrinkRealName = vDrinkParsed[0].tenNuocUong;  
    }
  }
    
  //display in console.log
  console.log("%cDETAIL BY CODE ORDER: ", "color:orange");
  console.log("Order Code: " + vOrderCode);
  console.log("Combo: " + vCombo);
  console.log("Pizza: " + vPizza);
  console.log("Drink: " + vDrinkRealName);
  console.log("Amount: " + vAmount);
  console.log("Fullname: " + vFullName);
  console.log("Phone: " + vPhone);
  console.log("Status: " + vStatus);
}

  //call API for getting the drink's list
  function callApiDrinkList(){
    debugger;
    var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", gBASE_URL_DRINK, false);
        vXmlHttp.send();
        
        vXmlHttp.onreadystatechange = function(){
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
            console.log("%cdrink list: ", "color:orange", this.responseText);
          }
        }
        var vDrinkParsing = JSON.parse(vXmlHttp.responseText);
            console.log("%cdrink list length: ", "color:orange", vDrinkParsing);
        return vXmlHttp.responseText;
  }

</script>

</html>